using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using System.Security;
using System.Runtime.ConstrainedExecution;

namespace InfiniTec.Security
{
    static class NativeMethods
    {
        [SecurityPermission(SecurityAction.Demand, UnmanagedCode = true)]
        [DllImport("advapi32.dll", SetLastError = true, CharSet = CharSet.Unicode)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool LogonUser(
            string lpszUsername,
            string lpszDomain,
            IntPtr lpszPassword,
            int dwLogonType,
            int dwLogonProvider,
            out UserToken phToken
            );

        [SecurityPermission(SecurityAction.Demand, UnmanagedCode = true)]
        [DllImport("kernel32.dll", CharSet = CharSet.Auto)]
        [return: MarshalAs(UnmanagedType.Bool)]
        [SuppressUnmanagedCodeSecurity]
        [ReliabilityContract(Consistency.WillNotCorruptState, Cer.Success)]
        public extern static bool CloseHandle(IntPtr handle);

        public enum LogonType : int
        {
            LOGON32_LOGON_INTERACTIVE = 2,
            LOGON32_LOGON_NETWORK = 3,
            LOGON32_LOGON_BATCH = 4,
            LOGON32_LOGON_SERVICE = 5,
            LOGON32_LOGON_UNLOCK = 7,
            LOGON32_LOGON_NETWORK_CLEARTEXT = 8,
            LOGON32_LOGON_NEW_CREDENTIALS = 9
        }

        public const int LOGON32_PROVIDER_DEFAULT = 0;

        [SecurityPermission(SecurityAction.Demand, UnmanagedCode = true)]
        [DllImport("credui.dll", EntryPoint = "CredUIConfirmCredentialsW", CharSet = CharSet.Unicode)]
        public static extern QueryCredentialError CredUIConfirmCredentials(string targetName, bool confirm);
    }

    static class UnsafeNativeMethods
    {
        [SecurityPermission(SecurityAction.Demand, UnmanagedCode = true)]
        [DllImport("credui", EntryPoint = "CredUIPromptForCredentialsW", CharSet = CharSet.Unicode)]
        public static extern unsafe QueryCredentialError CredUIPromptForCredentials(ref CREDUI_INFO creditUR,
                  string targetName,
                  IntPtr reserved1,
                  int iError,
                  StringBuilder userName,
                  int maxUserName,
                  char* password,
                  int maxPassword,
                  ref bool iSave,
                  QueryCredentialOptions flags);
        [SecurityPermission(SecurityAction.Demand, UnmanagedCode = true)]
        [DllImport("credui.dll", EntryPoint = "CredUICmdLinePromptForCredentialsW", CharSet = CharSet.Unicode)]
        public static extern unsafe QueryCredentialError CredUICmdLinePromptForCredentials(
            string targetName,
            IntPtr reserved,
            int authError,
            StringBuilder userName,
            int usernNameBufferSize,
            char* password,
            int passwordBufferSize,
            ref bool saveCredential,
            QueryCredentialOptions flags);

    }
    struct CREDUI_INFO
    {
        public int cbSize;
        public IntPtr hwndParent;
        [MarshalAs(UnmanagedType.LPWStr)]
        public string pszMessageText;
        [MarshalAs(UnmanagedType.LPWStr)]
        public string pszCaptionText;
        public IntPtr hbmBanner;
    }



    
}
